/* globals.h
 * declarations of global vars used by aint,
 * and possibly by the backend
 */

#ifndef GLOBALS_H
#define GLOBALS_H

#ifdef AINT_INIT
#define EXTERN
#else
#define EXTERN extern
#endif

// called at the beginning of aint_init and of aint_done respectively
EXTERN time_t Start_time, End_time;

// called at the beginning and at the end
EXTERN ulong Mem_size_start, Mem_size_end;

// the commandline name by which we were invoked
EXTERN char *Simname;

// true if -V specified on the command line
EXTERN aint_logical Verbose;


// numbers of dynamic instances of entities in the context hierarchy

EXTERN int ProcessCount;

EXTERN int ThreadCount;

EXTERN int PathCount;

EXTERN int FetchCount;

EXTERN aint_addr_t ObjHook;

EXTERN ulong Checkpoint_freq;

EXTERN ulong Stack_size;
EXTERN ulong Heap_size;

EXTERN ulong Shmem_start;
EXTERN ulong Shmem_end;
EXTERN ulong Shmem_size;

EXTERN char *job_separator;

EXTERN thread_ptr Threads[MAX_NTHREADS];

EXTERN int Maxpid;
EXTERN int Maxtid;

EXTERN int Print_Warnings;

// True in the AINT_issue function; to handle signals
EXTERN int AINT_in_issue;

#endif
