/* 
 * definitions required for opcodes/funs new to EV5, EV6, EV7:
 */

/* New flti_group fun codes: */
#define flti_sqrttc	0x02b
#define flti_sqrttm	0x06b
#define flti_sqrtt	0x0ab
#define flti_sqrttd	0x0eb
#define flti_sqrttuc	0x12b
#define flti_sqrttum	0x16b
#define flti_sqrttu	0x1ab
#define flti_sqrttud	0x1eb
#define flti_sqrttsuc	0x52b
#define flti_sqrttsum	0x56b
#define flti_sqrttsu	0x5ab
#define flti_sqrttsud	0x5eb
#define flti_sqrttsuic	0x72b
#define flti_sqrttsuim	0x76b
#define flti_sqrttsui	0x7ab
#define flti_sqrttsuid	0x7eb

#define flti_sqrtsc	0x00b
#define flti_sqrtsm	0x04b
#define flti_sqrts	0x08b
#define flti_sqrtsd	0x0cb
#define flti_sqrtsuc	0x10b
#define flti_sqrtsum	0x14b
#define flti_sqrtsu	0x18b
#define flti_sqrtsud	0x1cb
#define flti_sqrtssuc	0x50b
#define flti_sqrtssum	0x54b
#define flti_sqrtssu	0x58b
#define flti_sqrtssud	0x5cb
#define flti_sqrtssuic	0x70b
#define flti_sqrtssuim	0x74b
#define flti_sqrtssui	0x78b
#define flti_sqrtssuid	0x7cb

#define opc1c_perr 0x31

#define opc1c_minub8 0x3A
#define opc1c_minsb8 0x38

#define opc1c_minuw4 0x3B
#define opc1c_minsw4 0x39

#define opc1c_maxub8 0x3C
#define opc1c_maxsb8 0x3E

#define opc1c_maxuw4 0x3D
#define opc1c_maxsw4 0x3F

#define opc1c_pklb 0x37
#define opc1c_pkwb 0x36

#define opc1c_unpkbl 0x35
#define opc1c_unpkbw 0x34

#define opc1c_ctpop 0x30
#define opc1c_ctlz 0x32
#define opc1c_cttz 0x33

/* Integer/Floating Register Moves */

#define opc14_itofs 0x04 
#define opc14_itoff 0x14 
#define opc14_itoft 0x24 

#define opc1c_ftois 0x78
#define opc1c_ftoit 0x70

/* Write Hint */
#ifndef misc_ecb
#define misc_ecb 0xE800
#endif

#ifndef misc_wh64
#define misc_wh64 0xF800
#endif


OP(perr_f);
OP(minub8_f);
OP(minsb8_f);
OP(minuw4_f);
OP(minsw4_f);
OP(maxub8_f);
OP(maxsb8_f);
OP(maxuw4_f);
OP(maxsw4_f);
OP(pklb_f);
OP(pkwb_f);
OP(unpkbl_f);
OP(unpkbw_f);
OP(itofs_f);
OP(itoff_f);
OP(itoft_f);
OP(ctpop_f);
OP(ctlz_f);
OP(cttz_f);
OP(ftois_f);
OP(ftoit_f);
OP(ecb_f);
OP(wh64_f);
