/* protos.h
 * definitions of frequently used inlines/macros, and
 * prototypes of functions used in several source files
 */

#ifndef AINT_PROTOS_H
#define AINT_PROTOS_H


#define error aint_error

#define aint_error(_foo_) {cerr << "Error: " << _foo_ << endl;}

#define fatal(_foo_) { cerr << "Fatal: " << _foo_ << endl; exit(1); }

#define warning(_foo_) { if (Print_Warnings) cerr << "Warning: " << _foo_ << endl; }

#define informative(_foo_) {if (Verbose) cerr << _foo_ ; }

inline ulong BASE2ROUNDDOWN(const ulong n, const ulong power_of_two) {
  return (n & (~(power_of_two-1)));
}

inline ulong BASE2ROUNDUP(const ulong n, const ulong power_of_two) {
  return BASE2ROUNDDOWN(n + (power_of_two -1), power_of_two);
}

// 0 <= {n, return_value} < power_of_two
inline int SUCC_CIRC(int n, long power_of_two) {
  return (n+1)&(power_of_two - 1);
}

// 0 <= {n, return_value} < power_of_two
inline int PRED_CIRC(int n, long power_of_two) {
  return (n-1) & (power_of_two - 1);
}


// returns true if the address ranges overlap
inline int ADDR_OVERLAP(ulong addr1, int size1, ulong addr2, int size2) {
  return ( ((addr1 <= addr2) && (addr1+size1 > addr2)) 
	   || ((addr2 <= addr1) && (addr2+size2 > addr1)) );
}


extern void aint_cvt_fp_mem(unsigned int opnum, double fpreg, ulong *memloc);
extern int handle_signals_for_issue(int sig);

#endif
