#ifndef AINT_PTHREAD_H
#define AINT_PTHREAD_H

/* Header file for "fake" pthreads */

/* Include the syscall number definitions */
#include <aint_syscall.h>

/* This defines the interface to DU 4.0-like pthreads (POSIX 1003.1c-1995) */

/* The makefile should define _DEFINE_PTHREAD_TYPES if the standard header files do not provide those definitions */

/* For some reason, this doesn't get defined along with other pthread types */
typedef void * (*pthread_startroutine_t) (void *);

#ifdef _THREAD_SAFE

# ifdef __GNUC__
/* Prevent inclusion of c_asm.h. This is a dirty hack */
#  define __C_ASM_H
# endif
# include <pthread.h>

#else
/* We should not really be here... */
typedef void * pthread_t;
typedef void * pthread_attr_t;
typedef unsigned int pthread_key_t;

int pthread_create(pthread_t *, const pthread_attr_t *, void * (*)(void *), void *);

int pthread_join(pthread_t, void **);

int pthread_exit(void *);

int pthread_key_create(pthread_key_t *key, void (*destructor)(void *));

void * pthread_getspecific(pthread_key_t key);

int pthread_setspecific(pthread_key_t key, const void *value);

pthread_t pthread_self();

int pthread_equal(pthread_t t1, pthread_t t2);

#endif /* _THREAD_SAFE */

#endif
