/* mm.c: integer matrix multiply */

/* #define N 256 */

#include <stdio.h>

int main(int argc, char *argv[])
{
  int *A, *B, *C;
  int i, j, k, seed, N; 
  long s;

  sscanf(argv[1], "%d", &N);
  sscanf(argv[2], "%d", &seed);

  srandom(seed);

  A = (int *) malloc(N*N*sizeof(int));
  B = (int *) malloc(N*N*sizeof(int));
  C = (int *) malloc(N*N*sizeof(int));
  
  /* First create the matrices A and B */
  for (i=0; i<N; i++) for (j=0; j<N; j++) {
    A[i*N + j] = random()>>16;
    B[i*N + j] = random()>>16;
  }

  /* Multiply */
  for (i=0; i<N; i++) for (j=0; j<N; j++) {
    s = 0;
    for (k=0; k<N; k++) s += A[i*N + k]*B[k*N + j];
    C[i*N + j] = s;
  }

  s = 0;
  for (i=0; i<N; i++) for (j=0; j<N; j++) {
    s += C[i*N + j];
  }

  printf("Sum of elements is %ld\n", s);
}
