#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

int compar(void *a, void *b);

int main(int argc, char *argv[])
{
  int i, n;
  double d_prior, d_post;
  long *p;       

  /* Allocate an array of n longs, and fill it up with random numbers */
  int seed;

  if (argc != 3) {
    printf("Usage: qsort size seed\n");
    exit(1);
  }

  sscanf(argv[2], "%d", &seed);
  srandom(seed);
  // srandom((int)time(0));

  sscanf(argv[1], "%d", &n);

  p = (long *) malloc(n*sizeof(long));

  for (i=0; i<n; i++) *(p+i) = random();

  /* Find the total distance before */
  d_prior = 0;
  for (i=1; i<n; i++) d_prior += (double) (p[i]-p[i-1]);

  /* Sort the array */
  qsort(p, n, sizeof(long), compar);

  /* Find the total distance after */
  d_post = 0;
  for (i=1; i<n; i++) d_post += (double) (p[i] - p[i-1]);

  printf("Distance before was %g, after is %g\n", d_prior, d_post);
}

int compar(void *a, void *b)
{
  return (*(long *)a) - (*(long *)b);
}
