#include <stdio.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>

int main()
{
  /* Allocate two shmem segments */
  key_t k1, k2;
  int shmid1, shmid2;
  int pid;
  char *seg1, *seg2;
  struct shmid_ds buf;

  k1 = ftok("/vmunix", 1);
  k2 = ftok("/vmunix", 2);

  shmid1 = shmget(k1, 256, IPC_CREAT|0666);
  shmid2 = shmget(k2, 256, IPC_CREAT|0666);

  /* Fork off and attach the two segments */
  pid = fork();

  seg1 = shmat(shmid1, 0, 0);  
  seg2 = shmat(shmid2, 0, 0);  

  printf("\n%d: 0x%lx\n", pid, (long) (seg1));

  /* Parent: write message numbers, and wait for ack. Then write message */
  if (pid) {
    *seg1 = 0;
    strcpy(seg1, "Secret_Message!");
    strcpy(seg2, "Parent!");    
    while (strcmp(seg2, "Done!"));
    shmdt(seg1); shmdt(seg2);
    shmctl(shmid1, IPC_RMID, &buf);
    shmctl(shmid2, IPC_RMID, &buf);
  } else {
    while (strcmp(seg2, "Parent!"));
    puts("Child: got message..."); puts(seg1);
    strcpy(seg2, "Done!");
  }
}
  
