#include <stdio.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>

/* #define N 256 */

int main(int argc, char *argv[])
{

  key_t k1, k2, k3;
  int shmid1, shmid2, shmid3;
  int pid, status, N;

  float *A, *B, *C;
  int seed, i0, i, j0, j, k;
  double sum;

  if (argc < 3) {
    printf("Usage: parmm size seed\n");
    exit(1);
  }

  sscanf(argv[1], "%d", &N);

  k1 = ftok("/vmunix", 1);
  k2 = ftok("/vmunix", 2);
  k3 = ftok("/vmunix", 3);

  shmid1 = shmget(k1, N*N*sizeof(float), IPC_CREAT|0666);
  shmid2 = shmget(k2, N*N*sizeof(float), IPC_CREAT|0666);
  shmid3 = shmget(k3, N*N*sizeof(float), IPC_CREAT|0666);

  A = (float *) shmat(shmid1, 0, 0);
  B = (float *) shmat(shmid2, 0, 0);
  C = (float *) shmat(shmid3, 0, 0);

  /* Fill in the matrices A and B */
  sscanf(argv[2], "%d", &seed);
  srandom(seed);

  for (i=0; i<N; i++) for (j=0; j<N; j++) {
    float x1 = random();
    float x2 = random();
    float y1 = random();
    float y2 = random();
    A[i*N + j] = x1/x2;
    B[i*N + j] = y1/y2;
  }

  /* fork off four processes */
  pid = 0;
  if (fork() == 0) { 
    pid ++;
    if (fork() == 0) {
      pid ++;
      if (fork() == 0) {
	pid ++;
      }
    }
  }

  /* Do matmul on our part */

  i0 = (pid%2)*(N/2);
  j0 = (pid/2)*(N/2);

  for (i=0; i<N/2; i++) for (j=0; j<N/2; j++) {
    int row, col;
    float t = 0;
    
    row = (i0 + i);
    col = (j0 + j);
    for (k=0; k<N; k++) t += A[row*N + k]*B[k*N + col];

    C[row*N + col] = t;
  }

  wait(&status); 
  if (pid) exit(0);

  /* Last process - print out results */
  sum = 0;
  for (i=0; i<N; i++) for(j=0; j<N; j++) sum += C[i*N + j];

  printf("Sum is %g\n", sum);
}
